public inbox for gentoo-commits@lists.gentoo.org
 help / color / mirror / Atom feed
From: "Michał Górny" <mgorny@gentoo.org>
To: gentoo-commits@lists.gentoo.org
Subject: [gentoo-commits] repo/gentoo:master commit in: dev-python/pypy3/, dev-python/pypy3/files/
Date: Sat, 11 Apr 2020 07:49:28 +0000 (UTC)	[thread overview]
Message-ID: <1586591345.acbaf54ebedf109203ebe5f4fd6803ecbd36626d.mgorny@gentoo> (raw)

commit:     acbaf54ebedf109203ebe5f4fd6803ecbd36626d
Author:     Michał Górny <mgorny <AT> gentoo <DOT> org>
AuthorDate: Sat Apr 11 04:53:04 2020 +0000
Commit:     Michał Górny <mgorny <AT> gentoo <DOT> org>
CommitDate: Sat Apr 11 07:49:05 2020 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=acbaf54e

dev-python/pypy3: Bump to 7.3.1

Signed-off-by: Michał Górny <mgorny <AT> gentoo.org>

 dev-python/pypy3/Manifest                      |   1 +
 dev-python/pypy3/files/7.3.1-gentoo-path.patch |  42 +++++
 dev-python/pypy3/pypy3-7.3.1.ebuild            | 219 +++++++++++++++++++++++++
 3 files changed, 262 insertions(+)

diff --git a/dev-python/pypy3/Manifest b/dev-python/pypy3/Manifest
index ba24d510819..c119fbd7162 100644
--- a/dev-python/pypy3/Manifest
+++ b/dev-python/pypy3/Manifest
@@ -1 +1,2 @@
 DIST pypy3.6-v7.3.0-src.tar.bz2 21937786 BLAKE2B c53ac32a9cca1c4624160eae9f11b5705a59613f1e5100fbb0ee86118de5a7845b8fa5087165d7f5a077d20337dfca14a1c7eadbe768995e20e249ec271ac10d SHA512 313a4254262dd8d8b995a50bddbc360cfb67add0818e51a3e9ce25bda6a9b639e9fea8efe7da6adda76dff0a86a364544a13faa516e51b9ea6c25ec99223b435
+DIST pypy3.6-v7.3.1-src.tar.bz2 22712809 BLAKE2B 4250b3fe98c611b9635319c106b80e88ab469eab5f883babb738e175e7b7adc22c85f8ef3fdce1cdc127b521beef8d6c7862e188d8c8889c39f90136d6bbe374 SHA512 f8e32aae7f01225e0e4d6763eaac40fc02dffc3d0b6a30f22d422147f9be4f3290ea78160a912ffae311dea3d503eb31a7a4f3999d3b541fbccd93d1cef4ca56

diff --git a/dev-python/pypy3/files/7.3.1-gentoo-path.patch b/dev-python/pypy3/files/7.3.1-gentoo-path.patch
new file mode 100644
index 00000000000..fb73aec41de
--- /dev/null
+++ b/dev-python/pypy3/files/7.3.1-gentoo-path.patch
@@ -0,0 +1,42 @@
+From 6d439c6718625bb7dce32b0afdc6a3d5168a21e5 Mon Sep 17 00:00:00 2001
+From: =?UTF-8?q?Micha=C5=82=20G=C3=B3rny?= <mgorny@gentoo.org>
+Date: Sat, 11 Apr 2020 07:01:27 +0200
+Subject: [PATCH] Support Gentoo install scheme
+
+---
+ lib-python/3/distutils/command/install.py | 12 +++++++++++-
+ 1 file changed, 11 insertions(+), 1 deletion(-)
+
+diff --git a/lib-python/3/distutils/command/install.py b/lib-python/3/distutils/command/install.py
+index 6fe62be..a4e9f0d 100644
+--- a/lib-python/3/distutils/command/install.py
++++ b/lib-python/3/distutils/command/install.py
+@@ -97,6 +97,13 @@ INSTALL_SCHEMES = {
+         'scripts': '$base/Scripts',
+         'data'   : '$base',
+         },
++    'gentoo': {
++        'purelib': '$base/site-packages',
++        'platlib': '$base/site-packages',
++        'headers': '$base/include',
++        'scripts': '@EPREFIX@/usr/bin',
++        'data'   : '@EPREFIX@/usr',
++        },
+     }
+ 
+ # The keys to an installation scheme; if any new types of files are to be
+@@ -483,7 +490,10 @@ class install (Command):
+         # it's the caller's problem if they supply a bad name!
+         if (hasattr(sys, 'pypy_version_info') and
+                 not name.endswith(('_user', '_home'))):
+-            if os.name == 'nt':
++            if self.install_base == os.path.normpath('@EPREFIX@/usr/lib/pypy2.7'):
++                # override paths for system-wide install
++                name = 'gentoo'
++            elif os.name == 'nt':
+                 name = 'pypy_nt'
+             else:
+                 name = 'pypy'
+-- 
+2.26.0
+

diff --git a/dev-python/pypy3/pypy3-7.3.1.ebuild b/dev-python/pypy3/pypy3-7.3.1.ebuild
new file mode 100644
index 00000000000..ef18fb89b9f
--- /dev/null
+++ b/dev-python/pypy3/pypy3-7.3.1.ebuild
@@ -0,0 +1,219 @@
+# Copyright 1999-2020 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+PYTHON_COMPAT=( python2_7 )
+inherit pax-utils python-any-r1
+
+MY_P=pypy3.6-v${PV/_/}
+
+DESCRIPTION="A fast, compliant alternative implementation of the Python (3.6) language"
+HOMEPAGE="https://pypy.org/"
+SRC_URI="https://bitbucket.org/pypy/pypy/downloads/${MY_P}-src.tar.bz2"
+S="${WORKDIR}/${MY_P}-src"
+
+LICENSE="MIT"
+# pypy3 -c 'import sysconfig; print(sysconfig.get_config_var("SOABI"))'
+SLOT="0/pypy36-pp73"
+KEYWORDS="~amd64 ~ppc64 ~x86 ~amd64-linux ~x86-linux"
+IUSE="bzip2 gdbm +jit libressl ncurses sqlite test tk"
+RESTRICT="!test? ( test )"
+
+RDEPEND="
+	|| (
+		dev-python/pypy3-exe:${PV}[bzip2?,ncurses?]
+		dev-python/pypy3-exe-bin:${PV}
+	)
+	!libressl? ( dev-libs/openssl:0= )
+	libressl? ( dev-libs/libressl:0= )
+	gdbm? ( sys-libs/gdbm:0= )
+	sqlite? ( dev-db/sqlite:3= )
+	tk? (
+		dev-lang/tk:0=
+		dev-tcltk/tix:0=
+	)
+	!<dev-python/pypy3-bin-7.3.0:0"
+DEPEND="${RDEPEND}
+	test? (
+		${PYTHON_DEPS}
+		!!dev-python/pytest-forked
+	)"
+
+pkg_setup() {
+	use test && python-any-r1_pkg_setup
+}
+
+src_prepare() {
+	eapply "${FILESDIR}/7.3.1-gentoo-path.patch"
+	eapply "${FILESDIR}/1.9-distutils.unixccompiler.UnixCCompiler.runtime_library_dir_option.patch"
+	eapply "${FILESDIR}"/7.2.0-distutils-cxx.patch
+
+	sed -e "s^@EPREFIX@^${EPREFIX}^" \
+		-i lib-python/3/distutils/command/install.py || die
+
+	# apply CPython stdlib patches
+	pushd lib-python/3 > /dev/null || die
+	eapply "${FILESDIR}"/python-3.5-distutils-OO-build.patch
+	popd > /dev/null || die
+
+	# tests are copied from cpython and apparently not adjusted to pypy3
+	# or marked XFAIL
+	sed -i -e 's:test_runeval_step:_&:' \
+		lib-python/3/test/test_bdb.py || die
+	sed -i -e 's:test_set_nomemory:_&:' \
+		-e '/class PyMemDebugTests/i@unittest.skip("Broken on pypy3")' \
+		lib-python/3/test/test_capi.py || die
+	sed -i -e 's:test_crashing_decode_handler:_&:' \
+		lib-python/3/test/test_codeccallbacks.py || die
+	sed -i -e 's:test_unicode:_&:' \
+		lib-python/3/test/test_dbm_gnu.py || die
+	sed -i -e 's:test_jumpy:_&:' \
+		lib-python/3/test/test_dis.py || die
+	sed -i -e 's:test_generator_doesnt_retain_old_exc:_&:' \
+		-e 's:test_generator_finalizing_and_exc_info:_&:' \
+		-e 's:test_generator_leaking:_&:' \
+		lib-python/3/test/test_exceptions.py || die
+	sed -i -e 's:test_locale:_&:' \
+		lib-python/3/test/test_format.py || die
+	sed -i -e 's:test_ast_line_numbers:_&:' \
+		-e 's:test_backslashes_in_string_part:_&:' \
+		lib-python/3/test/test_fstring.py || die
+	sed -i -e 's:test_decompressor_bug_28275:_&:' \
+		lib-python/3/test/test_lzma.py || die
+	sed -i -e 's:test_listdir_bytes_like:_&:' \
+		-e 's:test_putenv:_&:' \
+		lib-python/3/test/test_posix.py || die
+	sed -i -e 's:test_auto_history:_&:' \
+		-e 's:test_history_size:_&:' \
+		lib-python/3/test/test_readline.py || die
+	sed -i -e 's:CheckDMLDoesNotAutoCommitBefore:_&:' \
+		-e 's:CheckImmediateTransactionalDDL:_&:' \
+		-e 's:CheckTransactionalDDL:_&:' \
+		lib-python/3/sqlite3/test/transactions.py || die
+	sed -i -e 's:test_pha_optional:_&:' \
+		-e 's:test_pha_required:_&:' \
+		lib-python/3/test/test_ssl.py || die
+	sed -i -e 's:test_eval_bytes_invalid_escape:_&:' \
+		-e 's:test_eval_str_invalid_escape:_&:' \
+		lib-python/3/test/test_string_literals.py || die
+	# the first one's broken by sandbox, the second by our env
+	sed -i -e 's:test_empty_env:_&:' \
+		-e 's:test_executable:_&:' \
+		lib-python/3/test/test_subprocess.py || die
+	sed -i -e 's:test_jump_out_of_async_for_block:_&:' \
+		-e 's:test_jump_over_async_for_block_before_else:_&:' \
+		-e 's:test_no_jump_.*wards_into_async_for_block:_&:' \
+		-e 's:test_no_jump_into_async_for_block_before_else:_&:' \
+		-e 's:test_no_jump_from_yield:_&:' \
+		lib-python/3/test/test_sys_settrace.py || die
+	sed -i -e 's:test_circular_imports:_&:' \
+		lib-python/3/test/test_threaded_import.py || die
+
+	eapply_user
+}
+
+src_compile() {
+	# copy over to make sys.prefix happy
+	cp -p "${BROOT}"/usr/lib/pypy3.6/pypy3-c-${PV} pypy3-c || die
+	cp -p "${BROOT}"/usr/lib/pypy3.6/include/${PV}/* include/ || die
+	# (not installed by pypy)
+	rm pypy/module/cpyext/include/_numpypy/numpy/README || die
+	mv pypy/module/cpyext/include/* include/ || die
+	mv pypy/module/cpyext/parse/*.h include/ || die
+	pax-mark m pypy3-c
+
+	einfo "Generating caches and CFFI modules ..."
+
+	# Generate Grammar and PatternGrammar pickles.
+	./pypy3-c -c "import lib2to3.pygram, lib2to3.patcomp; lib2to3.patcomp.PatternCompiler()" \
+		|| die "Generation of Grammar and PatternGrammar pickles failed"
+
+	# Generate cffi modules
+	# Please keep in sync with pypy/tool/build_cffi_imports.py!
+#cffi_build_scripts = {
+#    "_blake2": "_blake2/_blake2_build.py",
+#    "_ssl": "_ssl_build.py",
+#    "sqlite3": "_sqlite3_build.py",
+#    "audioop": "_audioop_build.py",
+#    "tk": "_tkinter/tklib_build.py",
+#    "curses": "_curses_build.py" if sys.platform != "win32" else None,
+#    "syslog": "_syslog_build.py" if sys.platform != "win32" else None,
+#    "gdbm": "_gdbm_build.py"  if sys.platform != "win32" else None,
+#    "pwdgrp": "_pwdgrp_build.py" if sys.platform != "win32" else None,
+#    "resource": "_resource_build.py" if sys.platform != "win32" else None,
+#    "lzma": "_lzma_build.py",
+#    "_decimal": "_decimal_build.py",
+#    "_sha3": "_sha3/_sha3_build.py",
+	cffi_targets=( blake2/_blake2 sha3/_sha3 ssl
+		audioop syslog pwdgrp resource lzma decimal )
+	use gdbm && cffi_targets+=( gdbm )
+	use ncurses && cffi_targets+=( curses )
+	use sqlite && cffi_targets+=( sqlite3 )
+	use tk && cffi_targets+=( tkinter/tklib )
+
+	local t
+	# all modules except tkinter output to .
+	# tkinter outputs to the correct dir ...
+	cd lib_pypy || die
+	for t in "${cffi_targets[@]}"; do
+		# tkinter doesn't work via -m
+		../pypy3-c "_${t}_build.py" || die "Failed to build CFFI bindings for ${t}"
+	done
+
+	# Cleanup temporary objects
+	find -name "_cffi_*.[co]" -delete || die
+	find -type d -empty -delete || die
+}
+
+src_test() {
+	# (unset)
+	local -x PYTHONDONTWRITEBYTECODE=
+	local -x COLUMNS=80
+
+	# Test runner requires Python 2 too. However, it spawns PyPy3
+	# internally so that we end up testing the correct interpreter.
+	"${EPYTHON}" ./pypy/test_all.py --pypy=./pypy3-c -vv lib-python || die
+}
+
+src_install() {
+	local dest=/usr/lib/pypy3.6
+	einfo "Installing PyPy ..."
+	dosym pypy3-c-${PV} "${dest}/pypy3-c"
+	insinto "${dest}"
+	# preserve mtimes to avoid obsoleting caches
+	insopts -p
+	doins -r include lib_pypy lib-python
+
+	# replace copied headers with symlinks
+	for x in "${BROOT}"/usr/lib/pypy3.6/include/${PV}/*; do
+		dosym "${PV}/${x##*/}" "${dest}/include/${x##*/}"
+	done
+
+	dosym ../lib/pypy3.6/pypy3-c /usr/bin/pypy3
+	dodoc README.rst
+
+	if ! use gdbm; then
+		rm -r "${ED}${dest}"/lib_pypy/_gdbm* || die
+	fi
+	if ! use sqlite; then
+		rm -r "${ED}${dest}"/lib-python/*3/sqlite3 \
+			"${ED}${dest}"/lib_pypy/_sqlite3* \
+			"${ED}${dest}"/lib-python/*3/test/test_sqlite.py || die
+	fi
+	if ! use tk; then
+		rm -r "${ED}${dest}"/lib-python/*3/{idlelib,tkinter} \
+			"${ED}${dest}"/lib_pypy/_tkinter \
+			"${ED}${dest}"/lib-python/*3/test/test_{tcl,tk,ttk*}.py || die
+	fi
+
+	local -x EPYTHON=pypy3
+	local -x PYTHON=${ED}${dest}/pypy3-c
+
+	echo "EPYTHON='${EPYTHON}'" > epython.py || die
+	python_moduleinto /usr/lib/pypy3.6/site-packages
+	python_domodule epython.py
+
+	einfo "Byte-compiling Python standard library..."
+	python_optimize "${ED}${dest}"
+}


             reply	other threads:[~2020-04-11  7:49 UTC|newest]

Thread overview: 15+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2020-04-11  7:49 Michał Górny [this message]
  -- strict thread matches above, loose matches on Subject: below --
2020-08-02  9:35 [gentoo-commits] repo/gentoo:master commit in: dev-python/pypy3/, dev-python/pypy3/files/ Michał Górny
2020-06-30 18:50 Michał Górny
2019-12-30 11:59 Michał Górny
2019-11-01  8:07 Michał Górny
2019-11-01  8:07 Michał Górny
2019-10-18 16:24 Michał Górny
2017-06-09 23:10 Michał Górny
2017-04-30 19:22 Michał Górny
2017-04-25 21:49 Michał Górny
2017-02-17 11:44 Michał Górny
2016-06-09 19:46 Michał Górny
2016-03-03 10:47 Michał Górny
2015-12-20 22:03 Michał Górny
2015-10-13 17:03 Julian Ospald

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1586591345.acbaf54ebedf109203ebe5f4fd6803ecbd36626d.mgorny@gentoo \
    --to=mgorny@gentoo.org \
    --cc=gentoo-commits@lists.gentoo.org \
    --cc=gentoo-dev@lists.gentoo.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox